grammar calc;

calc
	: lines EOF
	;
	
lines
	: line NL lines?
	;

line
	: expr
	;

expr 
	: term ((PLUS | MINUS) term)*
	;

term
	: factor ((MULT | DIV) factor)*
	;
	
factor
	: (PLUS | MINUS) factor
	| atom
	;

atom
	: INT
	| LPAR expr RPAR
	;
	
INT
	: '0'..'9'+
	;

PLUS
	: '+'
	;
	
MINUS
	: '-'
	;
	
MULT
	: '*'
	;
	
DIV
	: '/'
	;
	
LPAR
    : '('
    ;

RPAR
    : ')'
    ;

NL
	: '\r'|'\n'
	;

WHITESPACE
	: ('\t'|' '|'\u000C')+ { $channel = HIDDEN; }
	;
